'--------------------------------------------------------------
'  Project:            smartcard4-codelock
'  Date:                   12.10.2002
'  WEB:			 www.avr.4mg.com
'  Copyright:            Rudi Slejkovec
'  Device:           ATMEL AVR microcontroler
'--------------------------------------------------------------

$regfile = "2313def.dat"
$crystal = 4000000

Dim E As Byte , F As Byte , G As Byte
Dim H As Byte , P As Byte , R As Byte , S As Byte

Io Alias Pinb.6
Clk Alias Portb.5
Rst Alias Portb.4
C12 Alias Pinb.1
C34 Alias Pinb.0
Sto Alias Pinb.7
Cout Alias Pind.2
Beep Alias Portd.3
Rele Alias Portd.4
Cpow Alias Portd.5

Ddrb = &B0011_1100
Ddrd = &B1111_1011
Portb = 0
Portd = 0

Set Portd.2
Set Cpow

Begin:
Do
Waitms 100
If Cout = 0 Then
   Portb = 0
   Reset Cpow
   Waitms 40
   End If
If Cout = 1 Then Goto Begin
Set Rst
Set Clk
Waitms 10
Reset Clk
Waitms 10
Reset Rst
Set Clk
Waitms 10
Reset Clk
If Sto = 0 Then Gosub Store
If Sto = 1 Then Gosub Check1
Return
Return
Loop
End

Store:
For F = 0 To 31
    E = 0
   For G = 0 To 7
       E = E * 2
       E = E + Io
      Set Clk
      Waitms 10
      Reset Clk
   Next G
      If C34 = 0 Then
      H = 32 * C12
      End If
      If C34 = 1 Then
      H = 32 * C12
      H = H + 64
      End If
      H = H + F
   Writeeeprom E , H
Next F
Portb = 0
Set Cpow
P = 255
S = 1
Gosub Beeper
Takecard1:
If Cout = 0 Then
   Goto Takecard1
   End If
Return
End

Check1:
For F = 0 To 31
    E = 0
   For G = 0 To 7
       E = E * 2
       E = E + Io
      Set Clk
      Reset Clk
   Next G
   Readeeprom R , F
     If E <> R Then Goto Check2
     Goto Cont
End

Check2:
H = F + 32
Readeeprom R , H
   If E <> R Then Goto Check3
Goto Cont
End

Check3:
H = F + 64
Readeeprom R , H
   If E <> R Then Goto Check4
Goto Cont
End

Check4:
H = F + 96
Readeeprom R , H
   If E <> R Then Goto Error
Goto Cont
End

Cont:
Next F
Portb = 0
Set Cpow
P = 255
S = 1
Gosub Beeper
Takecard2:
If Cout = 0 Then
   Goto Takecard2
   End If
Wait 1
Set Rele
Wait 2
Reset Rele
Wait 1
Return
End

Error:
Portb = 0
Set Cpow
P = 90
S = 9
Gosub Beeper
Takecard3:
If Cout = 0 Then
   Goto Takecard3
   End If
Return
End

Beeper:
For F = 0 To S
   Set Beep
   Waitms P
   Reset Beep
   Waitms P
Next F
Return
End